#if !defined(AFX_QUEUE_H__A54DCD42_E1B4_11D5_B6EB_003042FFFD01__INCLUDED_)
#define AFX_QUEUE_H__A54DCD42_E1B4_11D5_B6EB_003042FFFD01__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

template <class QueueItem> class Queue
{
private:
	 QueueItem* m_buffer;
	 int m_count;
	 int m_bufsize;

public:
	Queue()
	{
		m_count=0;
		m_bufsize=0;
		m_buffer=0;
	}
	
	inline void Push(QueueItem& item)
	{
		if (m_bufsize<=m_count)
		{
			m_bufsize+=(m_bufsize == 0 ? 512 : 128); // min(50, m_bufsize/2 + 2);
			QueueItem* newbuffer=new QueueItem[m_bufsize];
			if (m_buffer)
			{
				// Only for structs! Not for heap memory!
				// memcpy(newbuffer, m_buffer, sizeof(QueueItem)*m_count);
				for (register int i=0; i<m_count; i++)
					newbuffer[i]=m_buffer[i];
				delete [] m_buffer;
			}
			m_buffer=newbuffer;
		}
		m_buffer[m_count++]=item;
	}

	void Pop(void) 
	{
		if (m_count<1) return;
		m_count--; // Don't really free the memory.
	}
	
	inline unsigned int Size(void) 
	{
		 return m_count;
	}
	void Clear(bool free_mem=true)
	{
		if (free_mem && m_buffer)
		{
			delete[] m_buffer;
			m_buffer=0; m_bufsize=0;
		}
		m_count=0;
	}

	inline QueueItem*	GetAt(int i)
	{
		#ifdef _DEBUG
		if(i<0 || i>=m_count) return 0L;
		#endif
		return &m_buffer[i];
	}
	
	~Queue() 
	{
		Clear();
	}
};

#endif // ndef Included
